﻿@page "/teams/create"
@page "/teams/edit/{Id:int}"

@using Models.TeamData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject ITeamRepository TeamRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Team</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@TeamModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Sport</label>
                        <InputText @bind-Value="currentSport" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="TeamModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => TeamModel.Name" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Team</button>
                        <NavLink href="teams" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private TeamDTO TeamModel { get; set; } = new TeamDTO();
    private string Title { get; set; } = "Create";
    private string currentSport { get; set; }
    protected override async Task OnInitializedAsync()
    {
        currentSport = await localStorage.GetItemAsync<string>("sportName");
        if (Id != null)
        {
            //update
            Title = "Update";
            TeamModel = await TeamRepository.Get(Id.Value);
        }
        else
        {
            //create
            TeamModel = new TeamDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if team is unique
            // --
            // --
            if (TeamModel.Id != 0 && Title == "Update")
            {
                //update
                var updateTeam = await TeamRepository.Update(TeamModel, TeamModel.Id);
                await JsRuntime.ToastrSuccess("Team updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/teams", true);

            }
            else
            {
                //create
                TeamModel.SportId = await localStorage.GetItemAsync<int>("sportId");
                var createdResult = await TeamRepository.Create(TeamModel);

                await JsRuntime.ToastrSuccess("Team created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/teams", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
